#!/bin/sh 
usb="$(find /media/ -not -empty -type d -maxdepth 1 | grep -o '[^/]\+$')"
/bin/echo ""; 
/bin/echo "CHECKSUMS:"; 
/usr/bin/openssl dgst -blake2b512 /media/"$usb"/localhost.apkovl.tar.gz; 
/usr/bin/openssl dgst -sha3-512 /media/"$usb"/localhost.apkovl.tar.gz; 
/bin/cp /etc/files/installed /media/"$usb"/cache;
/bin/cp /etc/files/world /etc/apk;
/bin/ln -sfn /media/"$usb"/cache /etc/apk/cache;
/bin/sed -i "1 s/.*/\/media\/"$usb"\/apks/" /etc/apk/repositories; 
/sbin/apk fix;
/bin/sleep 15
/bin/echo ""; 
/bin/echo "SHA-512 checksum:"; 
/usr/bin/sha512sum /media/"$usb"/localhost.apkovl.tar.gz; 
/bin/echo ""; 
/usr/bin/sha512sum -c /etc/files/512checksums.sha 2>&1 1>/dev/null;
/bin/echo ""; 
/sbin/ifconfig eth0 down; 
/usr/bin/macchanger -e eth0; 
/sbin/ifconfig eth0 up; 
/sbin/ifconfig wlan0 down; 
/usr/bin/macchanger -e wlan0; 
/sbin/ifconfig wlan0 up; 
/bin/echo ""; 
/bin/echo "Number of all files and folders on /media/"$usb":"; 
/usr/bin/find /media/"$usb"/* | /usr/bin/wc -l;
/bin/echo ""; 
/bin/echo "Number of all files and folders in the following folders:"; 
/bin/echo "/media/"$usb"/apks:"; 
/usr/bin/find /media/"$usb"/apks | /usr/bin/wc -l; 
/bin/echo "/media/"$usb"/boot:"; 
/usr/bin/find /media/"$usb"/boot | /usr/bin/wc -l; 
/bin/echo "/media/"$usb"/cache:"; 
/usr/bin/find /media/"$usb"/cache | /usr/bin/wc -l; 
/bin/echo "/media/"$usb"/files:"; 
/usr/bin/find /media/"$usb"/files | /usr/bin/wc -l; 
/bin/cp -rp /etc/home/* /home/; 
/bin/rm -r /etc/home; 
/bin/mkdir /etc/home; 
/bin/chmod 600 /etc/home; 
/bin/chmod 400 /etc/motd; 
/bin/cp -r /etc/files/aa-profile/* /etc/apparmor.d;
/bin/cp -r /etc/files/abstractions/* /etc/apparmor.d/abstractions;
/bin/cp -r /etc/files/local/* /etc/apparmor.d/local;
/bin/chown admin:admin /etc/motd;
/bin/mv /usr/sbin/resolvconf /sbin/resolvconf;
/bin/chown root:logcheck /var/log/messages; 
/bin/chmod 0700 /var/log/wtmp; 
/bin/chmod 0700 /usr/src /boot /lib/modules /usr/lib/modules;
/bin/echo "blacklist af_802154 \nblacklist appletalk \nblacklist atm \nblacklist ax25 \nblacklist bluetooth \nblacklist btusb \nblacklist can \nblacklist cifs \nblacklist cramfs \nblacklist dccp \nblacklist decnet \nbacklist econet \nblacklist freevxfs \nblacklist gfs2 \nblacklist hfs \nblacklist hfsplus \nblacklist ipx \nblacklist jffs2 \nblacklist ksmbd \nblacklist netrom \nblacklist nfs \nblacklist nfsv3 \nblacklist nfsv4 \nblacklist n-hdlc \nblacklist p8022 \nblacklist p8023 \nblacklist psnap \nblacklist rds \nblacklist rose \nblacklist sctp \nblacklist tipc \nblacklist udf \nblacklist uvcvideo \nblacklist vivid \nblacklist x25" >> /etc/modprobe.d/blacklist.conf
# /bin/chmod -s /bin/su; 
/bin/chmod +s /usr/bin/sway
/bin/chmod -s /usr/bin/expiry; 
/bin/chmod -s /usr/bin/newgrp; 
/bin/chmod -s /usr/bin/gpasswd; 
/bin/chmod -s /usr/bin/chfn; 
/bin/chmod -s /usr/bin/chage; 
/bin/chmod -s /usr/bin/chsh; 
/bin/chmod 660 /dev/net/tun;
/bin/mkdir /var/log/audit; 
/bin/touch /var/log/audit/audit.log; 
/bin/chmod 640 /var/log/audit/audit.log; 
/bin/chmod 750 /var/log/audit; 
/bin/chown root:root /var/log/audit/audit.log; 
/bin/chown root:root /var/log/audit; 
/bin/mv /usr/bin/auvirt /usr/bin/ausyscall /usr/bin/aulastlog /usr/bin/aulast /sbin; 
/bin/mv /usr/sbin/autrace /usr/sbin/ausearch /usr/sbin/aureport /usr/sbin/augenrules /usr/sbin/auditctl /usr/sbin/audisp-remote /usr/sbin/audispd /sbin;
/sbin/modprobe fat;
/sbin/modprobe ext4;
/sbin/modprobe vfat;
/sbin/modprobe tun;
/sbin/rc-service klogd start;
/sbin/rc-service nftables start;
/sbin/rc-service apparmor start;
/sbin/rc-service auditd start;
/sbin/rc-service seatd start;
/sbin/rc-service udev start;
/sbin/rc-service udev-trigger start;
/sbin/rc-service udev-settle start;
/sbin/rc-service alsa start;
/bin/echo ""; 
/usr/sbin/nft -f /etc/files/firewall.nft;
/bin/rm /etc/apparmor.d/usr.lib.dovecot*; 
/bin/rm /etc/apparmor.d/usr.lib.apache2*;
/usr/bin/aa-enforce /etc/apparmor.d/* > /dev/null;
